package org.herac.tuxguitar.player.impl.midiport.alsa;

import org.herac.tuxguitar.player.base.MidiOut;
import org.herac.tuxguitar.player.base.MidiPort;
import org.herac.tuxguitar.player.impl.midiport.alsa.MidiOutImpl;

public class MidiPortImpl extends MidiPort{

	private final int port;
	private final int client;
	private final MidiOutImpl midiOut;

	public MidiPortImpl(MidiSystem midiSystem,String name,int client,int port){
		super(MidiPortImpl.toString(client, port),name);
		this.client = client;
		this.port = port;
		this.midiOut = new MidiOutImpl(this,midiSystem);
	}
	
	public void open(){
		if(!this.midiOut.isConnected()){
			this.midiOut.connect();
		}
	}
	
	public void close(){
		this.midiOut.disconnect();
	}
	
	public MidiOut out(){
		this.open();
		return this.midiOut;
	}
	
	public void check(){
		// Not implemented
	}
	
	public int getPort() {
		return this.port;
	}

	public int getClient() {
		return this.client;
	}

	public static String toString(int client,int port){
		return (Integer.toString(client) + "-" + Integer.toString(port));
	}
	
}